Program TPDBDemo;
{Field  Field Name  Type       Width    Dec
	  1  CUSTNO      Character      5
	  2  FIRSTNAME   Character     20
	  3  MI          Character      1
	  4  LASTNAME    Character     25
	  5  ADDRESS     Character     35
	  6  CITY        Character     35
	  7  STATE       Character      2
	  8  ZIP         Character      5
	  9  ORDERNO     Character      9

	 10  ITEM        Character     20
	 11  COST        Numeric        8      2
	 12  SALEPRICE   Numeric        8      2
	 13  PROFIT      Numeric        8      2
	 14  SALEDATE    Date           8
	 15  COMPLETED   Logical        1
 ** Total **                     191}

{Demonstration of the capabilities of TPDB
 Version 2.0}

 Uses Crt,Dos,TPDB,TPDBDate,TPDBMath;

Var
	J : LongInt;
	SPos : Byte;
	Message : String[80];
	RecNo : string;
	Continue : Byte;

begin
	DBOpenFile('tpdbdemo.dbf');

	Repeat
	Continue := 0;
	NewDBRec;
	Repl(14,Today);
	Normal := White+BlueBG;
	Reverse := Black+LightGrayBG;
	SetColor(Black,LightGray);
	FlashFill(1,1,25,80,Blue+BlackBG,#176);
	Flash(2,5,Black+LightGrayBG,'Customer');
	Flash(3,5,Black+LightGrayBG,'Database');
	FlashC(2,White+RedBG,'TPDB Version 2.0');
	Flash(24,50,Black+LightGrayBG,'Press Esc Key When Finished.');
	FlashC(4,White+GreenBG,'Demonstration');
	Str(DBRecNum:10,RecNo);
	Message := 'Record Number: '+RecNo;
	Flash(2,50,White+RedBG,Message);
	Prompt(6,10,'Enter Customer Number: ');
	Say(1,6,33);
	Prompt(8,10,'First Name: ');
	Say(2,8,22);
	Prompt(10,10,'MI: ');
	Say(3,10,14);
	Prompt(12,10,'Last Name: ');
	Say(4,12,21);
	Prompt(14,10,'Address: ');
	Say(5,14,19);
	Prompt(16,10,'City: ');
	Say(6,16,16);
	Prompt(16,52,'State: ');
	Say(7,16,59);
	Prompt(16,63,'ZIP Code: ');
	Say(8,16,73);
	Prompt(18,10,'Order No.: ');
	Say(9,18,21);
	Prompt(18,35,'Item: ');
	Say(10,18,41);
	Prompt(20,10,'Cost: $');
	Say(11,20,17);
	Prompt(20,30,'Sale Price: $');
	Say(12,20,43);
	Prompt(20,55,'Profit: $');
	Say(13,20,64);
	Prompt(22,30,'Sale Date: ');
	Say(14,22,41);
	Prompt(24,10,'Transaction Completed ?: ');
	Say(15,24,35);

	BlockCursor;
	SPos := 1;

	Repeat
	Case SPos of
		1 : Get(1,6,33);
		2 : Get(2,8,22);
		3 : Get(3,10,14);
		4 : Get(4,12,21);
		5 : Get(5,14,19);
		6 : Get(6,16,16);
		7 : Get(7,16,59);
		8 : Get(8,16,73);
		9 : Get(9,18,21);
		10: Get(10,18,41);
		11: Get(11,20,17);
		12: Get(12,20,43);
		13:begin
			Repl(13,Sub(12,11));
			Say(13,20,65);
			end;
		14: Get(14,22,41);
		15: Get(15,24,35);
		end;
		CheckScreen(SPos,BC,Up,Down,1,15);
	Until BC in Next;
	AddDBRec;
	Flash(24,50,Blue+BlackBG,Replicate(#176,30));
	Flash(24,50,White+RedBG,'Add another record ? ');
	BC := GetBoolean(Continue,'Y','N',72,24);
	Until BoolToStr(Continue,'Y','N')='N';
	CloseDBFile;
	SetColor(Black,Black);
	ClrScr;
end.